//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <dir.h>
#pragma hdrstop

#include "MainSource.h"
#include "El\EBinaryEditSource.h"
#include "WingAreaSource.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::LoadFileBtnClick(TObject *Sender)
{
OpenDialog->InitialDir = Defaults->Strings[0];
if (OpenDialog->Execute()){
    Defaults->Strings[0] = ExtractFilePath(OpenDialog->FileName);
    DataFile->LoadFromFile(OpenDialog->FileName);
    PositionBox->Text = (int)DataFile->Position;
    SizeBox->Text = (int)DataFile->Size;
	LoadAirfoils();
    }


}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
//Load any default settings from ini file
ProfileName = 0;
RadioGroup1->ItemIndex = 0;
char * temp = new char[256];
getcurdir(0,temp);

ProgramDir = "\\";
ProgramDir += (AnsiString)temp;
delete temp;\

Defaults = new TStringList;
Defaults->LoadFromFile(ProgramDir + "\\defaults.ini");


//DataFile = new TMemoryStream;
DataFile = new EBinaryEdit;

nFoil = new Foil[360];
uFoil = new Foil[360];
dFoil = new Foil[360];

ScaleBoxX->Text = (AnsiString)(int)Image->Width / 360;

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
Defaults->SaveToFile(ProgramDir + "\\defaults.ini");
delete DataFile;
delete Defaults;
delete uFoil;
delete nFoil;
delete dFoil;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SaveFileBtnClick(TObject *Sender)
{
SaveDialog->InitialDir = Defaults->Strings[0];
if (SaveDialog->Execute()){
    Defaults->Strings[0] = ExtractFilePath(SaveDialog->FileName);
	SaveAirfoils();
	DataFile->SaveToFile(OpenDialog->FileName);
    }

}
//---------------------------------------------------------------------------
/*
AnsiString
TMainForm::GetString(long int position, int length)
{
AnsiString temp;

temp = "";
if (position > DataFile->Size) return "";
if (position + length > DataFile->Size) length = DataFile->Size - position;

DataFile->Position = position;

unsigned int * buffer = new unsigned int;

for (long int i=0;i<length;i++){
	*buffer = 0;
	DataFile->Read(buffer,1);
    temp = temp + (char)*buffer;
    }
delete buffer;
return temp;
}
*/
//---------------------------------------------------------------------------
/*
long int TMainForm::FindString(long int startpos, AnsiString text)
{
if (startpos > DataFile->Size) return -1;

for (long int i=startpos;i <= (DataFile->Size - text.Length());i++){
    if (GetString(i,text.Length()) == text) return i;
    }
return -1;

}

long int TMainForm::FindString(AnsiString text)
{
return FindString(DataFile->Position,text);
}
*/
//---------------------------------------------------------------------------
double TMainForm::LoadValue()
{
unsigned int * buffer = new unsigned int;
AnsiString temp;
temp = "";
do {*buffer = 0;
	DataFile->Read(buffer,1);
    if (*buffer != 0x20 && *buffer != 0x2c)
    	temp = temp + (char)*buffer;
    } while (*buffer != 0x20 && *buffer != 0x2c);
delete buffer;
return temp.ToDouble();

}
//---------------------------------------------------------------------------
void TMainForm::LoadAirfoils()
{
Foil * foil;
for (int c=0;c<3;c++){
    if (c==0) foil = nFoil;
    if (c==1) foil = uFoil;
    if (c==2) foil = dFoil;
	//Clean foil arrays
    for (int i=0; i<360;i++){
        foil[i].alpha = 0;
        for (int j=0;j<6;j++)
            foil[i].coefficient[j] = 0;
        }
    //load airfoil
    DataFile->Position = DataFile->FindString("dataRows ") + 9; //9 is the length of "dataRows "
    int i=0;
    do {foil[i].alpha = (double)LoadValue();
        for (int j=0;j<6;j++)
            foil[i].coefficient[j] = (double)LoadValue();
        i++;
        } while (DataFile->ReadString(DataFile->Position,1) != ")" && DataFile->Position--);
    if (c==0) nFoilSize = i - 1;
    if (c==1) uFoilSize = i - 1;
    if (c==2) dFoilSize = i - 1;
	}

switch (ProfileName){
	case 0 :	FillBoxes(nFoil,nFoilSize);
				DrawGraph(nFoil,nFoilSize);
                break;
    case 1 : 	FillBoxes(uFoil,uFoilSize);
				DrawGraph(uFoil,uFoilSize);
                break;
    case 2 : 	FillBoxes(dFoil,dFoilSize);
				DrawGraph(dFoil,dFoilSize);
                break;
    }




}
//-----------------------------------------------------------------------------
void TMainForm::FillBoxes(Foil * _foil,int _size)
{
ListBox1->Items->Clear();
ListBox2->Items->Clear();
ListBox3->Items->Clear();
ListBox4->Items->Clear();
ListBox5->Items->Clear();
ListBox6->Items->Clear();
ListBox7->Items->Clear();
AnsiString temp;
AnsiString ffa,ffr;
ffa = "' '000.00000;'-'000.00000;' '000.00000";
ffr = "' '00.00000;'-'00.00000;' '00.00000";
for (int i=0;i<=_size;i++){
    temp = temp.FormatFloat(ffa,(double)_foil[i].alpha);
    for (int j=0;j<6;j++){
	    temp += " : ";
      	temp +=temp.FormatFloat(ffr,(double)_foil[i].coefficient[j]);
        }
	ListBox1->Items->Add(temp);
    }

}
//---------------------------------------------------------------------------

void TMainForm::DrawGraph(Foil * _foil,int _size)
{
int yMax = 2;
int yMin = -2;
int xMax = 180;
int xMin = -180;
yscale = ScaleBoxY->Text.ToDouble();
xscale = ScaleBoxX->Text.ToDouble();

Image->Canvas->Brush->Color = clWhite;
Image->Canvas->FloodFill(1,1,clOlive,fsBorder);

//draw X axis
Plot(Image,-Image->Width/2,0);
LineTo(Image,Image->Width/2,0);
for (int i=-Image->Width/2;i<=Image->Width/2;i++){
    if (i%10 == 0){
    	Plot(Image,i,-5);
        LineTo(Image,i,5);
    	}
	}

//draw Y axis
Plot(Image,0,-Image->Height/2);
LineTo(Image,0,Image->Height/2);
for (int i=-Image->Height/2;i<=Image->Height;i++){
    if (i%10 == 0){
       	Plot(Image,-5,i);
        LineTo(Image,5,i);
        }
    }

int upper,lower,left;
upper = Image->Height - 30;
lower = Image->Height - 15;
left = Image->Left;
double xincrement = Image->Width / 50.0;


//draw numbers at the bottom
for (int i=0;i<5;i++)
	for (int j=0;j<10;j++){
    	Image->Canvas->TextOut((i*10+j)*xincrement,upper,(AnsiString)i);
    	Image->Canvas->TextOut((i*10+j)*xincrement,lower,(AnsiString)j);
        Image->Canvas->Pen->Color = clGray;
        Image->Canvas->MoveTo((i*10+j)*xincrement-1,0);
        Image->Canvas->LineTo((i*10+j)*xincrement-1,upper);
    	}




//plot graphs

TColor color;

for (int i=1;i<_size;i++){
    for (int j=0;j<6;j++){
        if (j==0)color = clRed;
        if (j==1)color = clGreen;
        if (j==2)color = clBlue;
        if (j==3)color = 0x00000055;
        if (j==4)color = 0x00005500;
        if (j==5)color = 0x00550000;
    	Plot(Image,_foil[i-1].alpha*xscale,_foil[i-1].coefficient[j]*yscale,color);
		LineTo(Image,_foil[i].alpha*xscale,_foil[i].coefficient[j]*yscale,color);
        }
    }


}
//---------------------------------------------------------------------------
void TMainForm::Plot(TImage * _image,int x, int y,TColor _color)
{
int xoffset = _image->Width / 2;
int yoffset = _image->Height / 2;

_image->Canvas->Pen->Color = _color;
_image->Canvas->MoveTo(x+xoffset,yoffset-y);
_image->Canvas->Ellipse(x+xoffset-2,yoffset-y-2,x+xoffset+2,yoffset-y+2);
//_image->Canvas->Pixels[x+xoffset][yoffset-y] = _color;

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RedrawBtnClick(TObject *Sender)
{
switch (ProfileName){
	case 0 :	DrawGraph(nFoil,nFoilSize);
                break;
    case 1 : 	DrawGraph(uFoil,uFoilSize);
                break;
    case 2 : 	DrawGraph(dFoil,dFoilSize);
                break;
    }

}
//---------------------------------------------------------------------------
void TMainForm::LineTo(TImage * _image,int x, int y,TColor _color)
{
int xoffset = _image->Width / 2;
int yoffset = _image->Height / 2;

_image->Canvas->Pen->Color = _color;
_image->Canvas->LineTo(x+xoffset,yoffset-y);
}
void __fastcall TMainForm::ListBox1Click(TObject *Sender)
{
ListBox2->TopIndex = ListBox3->TopIndex = ListBox4->TopIndex = ListBox5->TopIndex
	=ListBox6->TopIndex = ListBox7->TopIndex = ListBox1->TopIndex;

}
//---------------------------------------------------------------------------
//===========================================================================

void __fastcall TMainForm::Button1Click(TObject *Sender)
{
double left,right;
double leftm,rightm;
double factor;


left = ((Image->Width/50)*(LeftEdit->Text.ToDouble()-25) / xscale);
right = ((Image->Width/50)*(RightEdit->Text.ToDouble()-24) / xscale);



leftm = LeftMultiply->Text.ToDouble();
rightm = RightMultiply->Text.ToDouble();

factor = (rightm-leftm)/(right - left);

int e,size;

e = 1;

Foil * foil;
switch (ProfileName){
	case 0 : foil = nFoil;size = nFoilSize;break;
    case 1 : foil = uFoil;size = uFoilSize;break;
    case 2 : foil = dFoil;size = dFoilSize;break;
    }


int coeff = RadioGroup->ItemIndex;

if (coeff == -1)coeff = 1;

for (int i=0;i<size;i++)
	if (foil[i].alpha >= left && foil[i].alpha <= right)
		foil[i].coefficient[coeff] = foil[i].coefficient[coeff]
        * ((foil[i].alpha - left)*factor + leftm);

switch (ProfileName){
	case 0 : DrawGraph(nFoil,nFoilSize);break;
	case 1 : DrawGraph(uFoil,uFoilSize);break;
	case 2 : DrawGraph(dFoil,dFoilSize);break;
	}



}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RadioGroup1Click(TObject *Sender)
{
ProfileName = RadioGroup1->ItemIndex;
RedrawBtnClick(Sender);
}
//---------------------------------------------------------------------------
void TMainForm::SaveAirfoils()
{
DataFile->Position = 0;
Foil * foil;
for (int c=0;c<3;c++){
    if (c==0) foil = nFoil;
    if (c==1) foil = uFoil;
    if (c==2) foil = dFoil;
    //load airfoil
    DataFile->Position = DataFile->FindString("dataRows ") + 9; //9 is the length of "dataRows "
    int i=0;
    do {SaveValue(foil[i].alpha);
    	DataFile->Position++;
        for (int j=0;j<6;j++){
            SaveValue(foil[i].coefficient[j]);
            DataFile->Position++;
            }
        i++;
        } while (DataFile->ReadString(DataFile->Position,1) != ")" && DataFile->Position--);
	}
}
//---------------------------------------------------------------------------
void TMainForm::SaveValue(double _value)
{
//first check the length
unsigned int * buffer = new unsigned int;
int counter = 0;
do {*buffer = 0;
	DataFile->Read(buffer,1);
    if (*buffer != 0x20 && *buffer != 0x2c)
    	counter++;
    } while (*buffer != 0x20 && *buffer != 0x2c);

DataFile->Position -= (counter+1);
AnsiString temp;
char * c;
AnsiString * SaveValue = new AnsiString(_value);
*SaveValue = SaveValue->FormatFloat("0.0000000",_value);
for (int i=1;i<=counter;i++){
	if (i<=SaveValue->Length()){
        *buffer = 0;
         temp = SaveValue->SubString(i,1);
         c = temp.c_str();
         *buffer = (unsigned int)*c;
         } else {
         *buffer = 0x30;
         }
    DataFile->Write(buffer,1);
	}



delete SaveValue;
delete buffer;

}
void __fastcall TMainForm::WingAreaEditBtnClick(TObject *Sender)
{
WingAreaEditForm->ShowModal();
}
//---------------------------------------------------------------------------
