//---------------------------------------------------------------------------
#ifndef MainSourceH
#define MainSourceH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\Dialogs.hpp>
#include "El\EBinaryEditSource.h" 
//---------------------------------------------------------------------------
struct Foil {
	double alpha;
	double coefficient[6];
//	double Cl;
//   double Cd;
//    double Cm;
//    double dCl;
//    double dCd;
//    double dCm;
    };

//============================================================================
class TMainForm : public TForm
{
__published:	// IDE-managed Components
	TPanel *Panel2;
	TPanel *Panel3;
	TOpenDialog *OpenDialog;
	TEdit *PositionBox;
	TEdit *SizeBox;
	TListBox *ListBox1;
	TListBox *ListBox2;
	TListBox *ListBox3;
	TListBox *ListBox4;
	TListBox *ListBox5;
	TListBox *ListBox6;
	TListBox *ListBox7;
	TLabel *Label1;
	TLabel *Label2;
	TLabel *Label4;
	TLabel *Label5;
	TLabel *Label6;
	TLabel *Label7;
	TLabel *Label8;
	TImage *Image;
	TPanel *Panel1;
	TBitBtn *LoadFileBtn;
	TBitBtn *SaveFileBtn;
	TGroupBox *GroupBox1;
	TLabel *Label9;
	TLabel *Label10;
	TEdit *ScaleBoxY;
	TButton *RedrawBtn;
	TEdit *ScaleBoxX;
	TPanel *Panel4;
	TEdit *LeftEdit;
	TEdit *RightEdit;
	TEdit *RightMultiply;
	TEdit *LeftMultiply;
	TButton *Button1;
	TLabel *Label11;
	TLabel *Label12;
	TRadioGroup *RadioGroup;
	TRadioGroup *RadioGroup1;
	TSaveDialog *SaveDialog;
	TButton *WingAreaEditBtn;
	void __fastcall LoadFileBtnClick(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall SaveFileBtnClick(TObject *Sender);
	

	void __fastcall RedrawBtnClick(TObject *Sender);

	void __fastcall ListBox1Click(TObject *Sender);

	
	
	void __fastcall Button1Click(TObject *Sender);

	void __fastcall RadioGroup1Click(TObject *Sender);
	void __fastcall WingAreaEditBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
//    AnsiString GetString(long int position, int length);
//    long int FindString(long int startpos, AnsiString text);
//    long int FindString(AnsiString text);
    void LoadAirfoils();
	AnsiString FileName;
	double LoadValue();
	EBinaryEdit * DataFile;
	__fastcall TMainForm(TComponent* Owner);
    Foil * nFoil;
    Foil * uFoil;
    Foil * dFoil;
    int nFoilSize;
    int uFoilSize;
    int dFoilSize;
    void FillBoxes(Foil * _foil,int _size);
    void DrawGraph(Foil * _foil,int _size);
    void Plot(TImage * _image,int x, int y,TColor _color=clBlack);
    void LineTo(TImage * _image,int x, int y,TColor _color=clBlack);
    TStringList * Defaults;
    AnsiString ProgramDir;
    double xscale;
    double yscale;
    short int ProfileName;
    void SaveAirfoils();
    void SaveValue(double _value);
};
//---------------------------------------------------------------------------
extern TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
